Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34921)
@@ -1045,5 +4750,743 @@
         },
     },
-    # 0x56 - something to do with JPEG quality?
+    0x55 => { # (copied from CameraSettings, ref JR)
+        Name => 'AspectRatio',
+        PrintConv => {
+            1 => '3:2',
+            2 => '16:9',
+        },
+    },
+    0x56 => { # (copied from CameraSettings, ref JR)
+        Name => 'Quality',
+        PrintConv => {
+            0 => 'RAW',
+            2 => 'CRAW',
+            34 => 'RAW + JPEG',
+            35 => 'CRAW + JPEG',
+            16 => 'Extra Fine',
+            32 => 'Fine',
+            48 => 'Standard',
+        },
+    },
+    0x58 => { # (copied from CameraSettings, ref JR)
+        Name => 'ExposureLevelIncrements',
+        PrintConv => {
+            33 => '1/3 EV',
+            50 => '1/2 EV',
+        },
+    },
+### 0x5a onwards: subtract 1 from CameraSettings TagID
+    # (0x69 not confirmed)
+    #0x69 => { #JR
+    #    Name => 'RedEyeReduction',
+    #    PrintConv => {
+    #        0 => 'Off',
+    #        1 => 'On',
+    #    },
+    #},
+    0x7e => { #JR
+        Name => 'DriveMode',
+        Mask => 0xff, # (not sure what upper byte is for)
+        PrintConv => { # (values confirmed for specified models - PH)
+            1 => 'Single Frame', # (A230,A330,A380)
+            2 => 'Continuous High', #PH (A230,A330)
+            4 => 'Self-timer 10 sec', # (A230)
+            5 => 'Self-timer 2 sec, Mirror Lock-up', # (A230,A290,A330,A380,390)
+            7 => 'Continuous Bracketing', # (A230 val=0x1107, A330 val=0x1307 [0.7 EV])
+            10 => 'Remote Commander', # (A230)
+            11 => 'Continuous Self-timer', # (A230 val=0x800b [5 shots], A330 val=0x400b [3 shots])
+        },
+    },
+    0x7f => { #JR
+        Name => 'FlashMode',
+        PrintConv => {
+            0 => 'Autoflash',
+            2 => 'Rear Sync',
+            3 => 'Wireless',
+            4 => 'Fill-flash',
+            5 => 'Flash Off',
+            6 => 'Slow Sync',
+        },
+    },
+    0x83 => { #PH
+        Name => 'ColorSpace',
+        PrintConv => {
+            5 => 'Adobe RGB',
+            6 => 'sRGB',
+        },
+    },
+);
+
+# more Camera settings (ref PH)
+# This was decoded for the A55, but it seems to apply to the following models:
+# A33, A35, A55, A450, A500, A550, A560, A580, NEX-3, NEX-5, NEX-C3 and NEX-VG10E
+%Image::ExifTool::Sony::CameraSettings3 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FORMAT => 'int8u',
+    PRIORITY => 0,
+    DATAMEMBER => [ 0x99 ],
+    NOTES => q{
+        Camera settings for models such as the A33, A35, A55, A450, A500, A550,
+        A560, A580, NEX-3, NEX-5, NEX-C3 and NEX-VG10E.
+    },
+    0x00 => { #JR
+        Name => 'ShutterSpeedSetting',
+        Notes => 'used only in M and S exposure modes',
+        ValueConv => '$val ? 2 ** (6 - $val/8) : 0',
+        ValueConvInv => '$val ? int((6 - log($val) / log(2)) * 8 + 0.5) : 0',
+        PrintConv => '$val ? Image::ExifTool::Exif::PrintExposureTime($val) : "Bulb"',
+        PrintConvInv => 'lc($val) eq "bulb" ? 0 : Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x01 => { #JR
+        Name => 'ApertureSetting',
+        Notes => 'used only in M and A exposure modes',
+        ValueConv => '2 ** (($val/8 - 1) / 2)',
+        ValueConvInv => 'int((log($val) * 2 / log(2) + 1) * 8 + 0.5)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
+        PrintConvInv => '$val',
+    },
+    0x02 => {
+        Name => 'ISOSetting',
+        ValueConv => '($val and $val < 254) ? exp(($val/8-6)*log(2))*100 : $val',
+        ValueConvInv => '($val and $val != 254) ? 8*(log($val/100)/log(2)+6) : $val',
+        PrintConv => {
+            OTHER => sub {
+                my ($val, $inv) = @_;
+                return int($val + 0.5) unless $inv;
+                return Image::ExifTool::IsFloat($val) ? $val : undef;
+            },
+            0 => 'Auto',
+            254 => 'n/a', # get this for multi-shot noise reduction
+        },
+    },
+    0x03 => { #JR
+        Name => 'ExposureCompensationSet',
+        ValueConv => '($val - 128) / 24', #PH
+        ValueConvInv => 'int($val * 24 + 128.5)',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x04 => { #JR
+        Name => 'DriveModeSetting',
+        # Same drivemode info is repeated in 0x0034, but with at least the following exceptions:
+        # - 0x0034 not for A550 ? - seen "0"
+        # - hand-held night   (0x05=56): 0x0004=0x10 and 0x0034=0xd3
+        # - 3D sweep panorama (0x05=57): 0x0004=0x10 and 0x0034=0xd6
+        # - sweep panorama    (0x05=80): 0x0004=0x10 and 0x0034=0xd5
+        # preliminary conclusion: 0x0004 is Drivemode as pre-set, but may be overruled by Scene/Panorama mode selections
+        #                         0x0034 is Divemode as actually used
+        PrintHex => 1,
+        PrintConv => {
+            0x10 => 'Single Frame',
+            0x21 => 'Continuous High', # also automatically selected for Scene mode Sports-action (0x05=52)
+            0x22 => 'Continuous Low',
+            0x30 => 'Speed Priority Continuous',
+            0x51 => 'Self-timer 10 sec',
+            0x52 => 'Self-timer 2 sec, Mirror Lock-up',
+            0x71 => 'Continuous Bracketing 0.3 EV',
+            0x75 => 'Continuous Bracketing 0.7 EV',
+            0x91 => 'White Balance Bracketing Low',
+            0x92 => 'White Balance Bracketing High',
+            0xc0 => 'Remote Commander',
+        },
+    },
+    0x05 => { #JR
+        Name => 'ExposureProgram',
+        # Camera exposure program/mode as selected with the Mode dial.
+        # For SCN a further selection is done via the menu
+        # Matches OK with 0xb023
+        SeparateTable => 'ExposureProgram2',
+        PrintConv => \%sonyExposureProgram2,
+    },
+    0x06 => { #JR
+        Name => 'FocusModeSetting',
+        PrintConv => {
+            17 => 'AF-S',
+            18 => 'AF-C',
+            19 => 'AF-A',
+            32 => 'Manual',
+            48 => 'DMF', #(NC) (seen for NEX-5)
+        },
+    },
+    0x07 => { #JR
+        Name => 'MeteringMode',
+        PrintConv => {
+            1 => 'Multi-segment',
+            2 => 'Center-weighted average',
+            3 => 'Spot',
+        },
+    },
+    0x09 => { #JR
+        Name => 'SonyImageSize',
+        PrintConv => {  # values confirmed as noted for the A580 and A33
+           21 => 'Large (3:2)',    # A580: 16M  (4912x3264), A33: 14M  (4592x3056)
+           22 => 'Medium (3:2)',   # A580: 8.4M (3568x2368), A33: 7.4M (3344x2224)
+           23 => 'Small (3:2)',    # A580: 4.0M (2448x1624), A33: 3.5M (2288x1520)
+           25 => 'Large (16:9)',   # A580: 14M  (4912x2760)
+           26 => 'Medium (16:9)',  # A580: 7.1M (3568x2000)
+           27 => 'Small (16:9)',   # A580: 3.4M (2448x1376)
+        },
+    },
+    0x0a => { #JR
+        Name => 'AspectRatio',
+        # normally 4 for A580 3:2 ratio images
+        # seen 8 when selecting 16:9 via menu, and when selecting Panorama mode
+        PrintConv => {
+            4 => '3:2',
+            8 => '16:9',
+        },
+    },
+    0x0b => { #JR
+        Name => 'Quality',
+        PrintConv => {
+            2 => 'RAW',
+            4 => 'RAW + JPEG',
+            6 => 'Fine',
+            7 => 'Standard',
+        },
+    },
+    0x0c => {
+        Name => 'DynamicRangeOptimizerSetting',
+        PrintConv => {
+            1 => 'Off',
+            16 => 'On (Auto)',
+            17 => 'On (Manual)',
+        },
+    },
+    0x0d => 'DynamicRangeOptimizerLevel',
+    0x0e => { #JR
+        Name => 'ColorSpace',
+        PrintConv => {
+            1 => 'sRGB',
+            2 => 'Adobe RGB',
+        },
+    },
+    0x0f => { #JR
+        Name => 'CreativeStyleSetting',
+        PrintConvColumns => 2,
+        PrintConv => {
+            16 => 'Standard',
+            32 => 'Vivid',
+            64 => 'Portrait',
+            80 => 'Landscape',
+            96 => 'B&W',
+            160 => 'Sunset',
+        },
+    },
+    0x10 => { #JR (seen values 253, 254, 255, 0, 1, 2, 3)
+        Name => 'ContrastSetting',
+        Format => 'int8s',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x11 => { #JR
+        Name => 'SaturationSetting',
+        Format => 'int8s',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x12 => { #JR
+        Name => 'SharpnessSetting',
+        Format => 'int8s',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x16 => { #JR
+        Name => 'WhiteBalanceSetting',
+        # many guessed, based on "logical system" as observed for Daylight and Shade and steps of 16 between the modes
+        PrintHex => 1,
+        PrintConvColumns => 2,
+        PrintConv => \%whiteBalanceSetting,
+        SeparateTable => 1,
+    },
+    0x17 => { #JR
+        Name => 'ColorTemperatureSetting',
+        # matches "0xb021 ColorTemperature" when WB set to "Custom" or "Color Temperature/Color Filter"
+        ValueConv => '$val * 100',
+        ValueConvInv => '$val / 100',
+        PrintConv => '"$val K"',
+        PrintConvInv => '$val =~ s/ ?K$//i; $val',
+    },
+    0x18 => { #JR
+        Name => 'ColorCompensationFilterSet',
+        # seen 0, 1-9 and 245-255, corresponding to 0, M1-M9 and G9-G1 on camera display
+        # matches "0xb022 ColorCompensationFilter" when WB set to "Custom" or "Color Temperature/Color Filter"
+        Format => 'int8s',
+        Notes => 'negative is green, positive is magenta',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x19 => { #JR
+        Name => 'CustomWB_RGBLevels',
+        Format => 'int16uRev[3]',
+        # 0x19 - 0x1e are related to Custom WB measurements performed by the camera.
+        # The values change only each time when measuring and setting a new Custom WB.
+        # (0x19,0x1a) and (0x1d,0x1e) are same as MoreSettings (0x1a,0x1b) and (0x1c,0x1d)
+    },
+    # 0x1f - always 2 (ref JR)
+    0x20 => { #JR
+        Name => 'FlashMode',
+        PrintConvColumns => 2,
+        PrintConv => {
+            1 => 'Flash Off',
+            16 => 'Autoflash',
+            17 => 'Fill-flash',
+            18 => 'Slow Sync',
+            19 => 'Rear Sync',
+            20 => 'Wireless',
+        },
+    },
+    0x21 => { #JR
+        Name => 'FlashControl',
+        PrintConv => {
+            1 => 'ADI Flash',
+            2 => 'Pre-flash TTL',
+        },
+    },
+    0x23 => { #JR
+        Name => 'FlashExposureCompSet',
+        Description => 'Flash Exposure Comp. Setting',
+        # (as pre-selected by the user, not zero if flash didn't fire)
+        ValueConv => '($val - 128) / 24', #PH
+        ValueConvInv => 'int($val * 24 + 128.5)',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x24 => {
+        Name => 'AFAreaMode',
+        PrintConv => {
+            1 => 'Wide',
+            2 => 'Spot',
+            3 => 'Local',
+            4 => 'Flexible', #JR
+            # (Flexible Spot is a grid of 17x11 points for the NEX-5)
+        },
+    },
+    0x25 => { #JR
+        Name => 'LongExposureNoiseReduction',
+        PrintConv => {
+            1 => 'Off',
+            16 => 'On',  # (unused or dark subject)
+        },
+    },
+    0x26 => { #JR
+        Name => 'HighISONoiseReduction',
+        PrintConv => {
+            16 => 'Low',
+            17 => 'High',
+            19 => 'Auto',
+        },
+    },
+    0x27 => { #JR
+        Name => 'SmileShutterMode',
+        PrintConv => {
+            17 => 'Slight Smile',
+            18 => 'Normal Smile',
+            19 => 'Big Smile',
+        },
+    },
+    0x28 => { #JR
+        Name => 'RedEyeReduction',
+        PrintConv => {
+            1 => 'Off',
+            16 => 'On',
+        },
+    },
+    0x2d => {
+        Name => 'HDRSetting',
+        PrintConv => {
+            1 => 'Off',
+            16 => 'On (Auto)',
+            17 => 'On (Manual)',
+        },
+    },
+    0x2e => {
+        Name => 'HDRLevel',
+        PrintConvColumns => 3,
+        PrintConv => {
+            33 => '1 EV',
+            34 => '1.5 EV', #JR (NC)
+            35 => '2 EV',
+            36 => '2.5 EV', #JR (NC)
+            37 => '3 EV',
+            38 => '3.5 EV', #PH (NC)
+            39 => '4 EV',
+            40 => '5 EV',
+            41 => '6 EV',
+        },
+    },
+    0x2f => { #JR (not sure what is difference with 0x85)
+        Name => 'ViewingMode',
+        PrintConv => {
+            16 => 'ViewFinder',
+            33 => 'Focus Check Live View',
+            34 => 'Quick AF Live View',
+        },
+    },
+    0x30 => { #JR
+        Name => 'FaceDetection',
+        PrintConv => {
+            1 => 'Off',
+            16 => 'On',
+        },
+    },
+    0x31 => { #JR
+        Name => 'SmileShutter',
+        PrintConv => {
+            1 => 'Off',
+            16 => 'On',
+        },
+    },
+    0x32 => { #JR
+        Name => 'SweepPanoramaSize',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        PrintConv => {
+            1 => 'Standard',
+            2 => 'Wide',
+        },
+    },
+    0x33 => { #JR
+        Name => 'SweepPanoramaDirection',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        PrintConv => {
+            1 => 'Right',
+            2 => 'Left',
+            3 => 'Up',
+            4 => 'Down',
+        },
+    },
+    0x34 => { #JR
+        Name => 'DriveMode', # (drive mode actually used)
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        PrintHex => 1,
+        PrintConv => {
+            0x10 => 'Single Frame',
+            0x21 => 'Continuous High', # also automatically selected for Scene mode Sports-action (0x05=52)
+            0x22 => 'Continuous Low',
+            0x30 => 'Speed Priority Continuous',
+            0x51 => 'Self-timer 10 sec',
+            0x52 => 'Self-timer 2 sec, Mirror Lock-up',
+            0x71 => 'Continuous Bracketing 0.3 EV',
+            0x75 => 'Continuous Bracketing 0.7 EV',
+            0x91 => 'White Balance Bracketing Low',
+            0x92 => 'White Balance Bracketing High',
+            0xc0 => 'Remote Commander',
+            0xd1 => 'Continuous - HDR',
+            0xd2 => 'Continuous - Multi Frame NR',
+            0xd3 => 'Continuous - Handheld Night Shot', # (also called "Hand-held Twilight")
+            0xd4 => 'Continuous - Anti Motion Blur', #PH (NEX-5)
+            0xd5 => 'Continuous - Sweep Panorama',
+            0xd6 => 'Continuous - 3D Sweep Panorama',
+        },
+    },
+    0x35 => {
+        Name => 'MultiFrameNoiseReduction',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        PrintConv => {
+            0 => 'n/a', # seen for A450/A500/A550
+            1 => 'Off',
+            16 => 'On',
+            255 => 'None', # seen for NEX-3/5/C3
+        },
+    },
+    0x36 => { #JR (not 100% sure about this one)
+        Name => 'LiveViewAFSetting',
+        Condition => '$$self{Model} !~ /^(NEX-|DSLR-(A450|A500|A550)$)/',
+        PrintConv => {
+            0 => 'n/a',
+            1 => 'Phase-detect AF',
+            2 => 'Contrast AF',
+            # Contrast AF is only available with SSM/SAM lenses and in Focus Check LV,
+            # NOT in Quick AF LV, and is automatically set when mounting SSM/SAM lens
+            # - changes into Phase-AF when switching to Quick AF LV.
+        },
+    },
+    0x38 => { #JR
+        Name => 'PanoramaSize3D',
+        Description => '3D Panorama Size',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        PrintConv => {
+            0 => 'n/a',
+            1 => 'Standard',
+            2 => 'Wide',
+            3 => '16:9',
+        },
+    },
+    0x83 => { #JR
+        Name => 'AFButtonPressed',
+        # only indicates pressing and holding the "AF" button (centre-controller),
+        # not pressing the shutter release button halfway down
+        Condition => '$$self{Model} !~ /^(NEX-|DSLR-(A450|A500|A550)$)/',
+        PrintConv => {
+            1 => 'No',
+            16 => 'Yes',
+        },
+    },
+    0x84 => { #JR (not 100% sure about this one)
+        Name => 'LiveViewMetering',
+        Condition => '$$self{Model} !~ /^(NEX-|DSLR-(A450|A500|A550)$)/',
+        PrintConv => {
+            0 => 'n/a',
+            16 => '40 Segment',             # DSLR with LiveView/OVF switch in OVF position
+            32 => '1200-zone Evaluative',   # SLT, or DSLR with LiveView/OVF switch in LiveView position
+        },
+    },
+    0x85 => { #JR (not sure what is difference with 0x2f)
+        Name => 'ViewingMode2',
+        Condition => '$$self{Model} !~ /^(NEX-|DSLR-(A450|A500|A550)$)/',
+        PrintConv => {
+            0 => 'n/a',
+            16 => 'Viewfinder',
+            33 => 'Focus Check Live View',
+            34 => 'Quick AF Live View',
+        },
+    },
+    0x86 => { #JR
+        Name => 'AELock',
+        Condition => '$$self{Model} !~ /^(NEX-|DSLR-(A450|A500|A550)$)/',
+        PrintConv => {
+            1 => 'On',
+            2 => 'Off',
+        },
+    },
+    0x87 => { #JR
+        Name => 'FlashStatusBuilt-in',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)/',
+        PrintConv => {
+            1 => 'Off',
+            2 => 'On',
+        },
+    },
+    0x88 => { #JR
+        Name => 'FlashStatusExternal',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)/',
+        PrintConv => {
+            1 => 'None',
+            2 => 'Off',
+            3 => 'On',
+        },
+    },
+#    0x8a => { #JR
+#        Name => 'LensAF',
+#        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+#        PrintConv => {
+#            1  => 'No',
+#            16 => 'AF Lens',
+#        },
+#    },
+    0x8b => { #JR
+        Name => 'LiveViewFocusMode',
+        Condition => '$$self{Model} !~ /^(NEX-|DSLR-(A450|A500|A550)$)/',
+        PrintConv => {
+            0 => 'n/a',
+            1 => 'AF',
+            16 => 'Manual',
+        },
+    },
+#    0x8e => { #JR
+#        Name => 'LensSAM',
+#        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+#        PrintConv => {
+#            1  => 'No',
+#            16 => 'SAM Lens',
+#        },
+#    },
+    0x99 => { #JR
+        Name => 'LensMount',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        DataMember => 'LensMount',
+        RawConv => '$$self{LensMount} = $val',
+        PrintConv => {
+            1  => 'Unknown',
+            16 => 'A-mount',
+            17 => 'E-mount',
+        },
+    },
+#    0x9b => { #JR
+#        Name => 'LensOSS',
+#        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+#        PrintConv => {
+#            1  => 'No',
+#            16 => 'OSS Lens',
+#            17 => 'OSS Lens (NEX-VG)', # active ?
+#        },
+#    },
+    # 0x9c - 1; 2 for multi-shot modes
+    0x10c => { #JR
+        Name => 'SequenceNumber',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/', # seen 18 for A550, so better exclude ?
+        # normally 0; seen 1,2,3 for bracketing, 6 for Handheld Night Shot, 3 for HDR, 6 for MFNR
+        PrintConv => {
+            0 => 'Single',
+            255 => 'n/a',
+            OTHER => sub { shift }, # pass all other numbers straight through
+        },
+    },
+    # when reading 0x0114 - 0x0117 as int32u:
+    # - upper 8 bits (0x0117): always value 4, meaning unknown
+    # - next 10 bits: FolderNumber (max. 999 according to manual)
+    # - last 14 bits: ImageNumber  (max 9999)
+    0x0114 => { #JR
+        Name => 'FolderNumber',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        Format => 'int32u',
+        Mask => 0x00ffc000,
+        PrintConv => 'sprintf("%.3d",$val)',
+        PrintConvInv => '$val',
+    },
+    276.1 => { #JR (0x0114.1)
+        Name => 'ImageNumber',
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        Format => 'int32u',
+        Mask => 0x00003fff,
+        PrintConv => 'sprintf("%.4d",$val)',
+        PrintConvInv => '$val',
+    },
+    0x200 => { #JR
+        Name => 'ShotNumberSincePowerUp2',
+        Notes => q{
+            same as ShotNumberSincePowerUp for single-shot images, but includes all
+            shots of the current image in multi-shot modes like HDR, panorama, and
+            multi-frame noise reduction
+        },
+        # (includes all shutter actuations of the current shot)
+        Condition => '$$self{Model} !~ /^DSLR-(A450|A500|A550)$/',
+        Format => 'int32u',
+    },
+    0x283 => { #JR
+        Name => 'AFButtonPressed',
+        # only indicates pressing and holding the "AF" button (centre-controller),
+        # not pressing the shutter release button halfway down
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        PrintConv => {
+            1 => 'No',
+            16 => 'Yes',
+        },
+    },
+    0x284 => { #JR (not 100% sure about this one)
+        Name => 'LiveViewMetering',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        PrintConv => {
+            0 => 'n/a',
+            16 => '40 Segment',             # DSLR with LiveView/OVF switch in OVF position
+            32 => '1200-zone Evaluative',   # DSLR with LiveView/OVF switch in LiveView position
+        },
+    },
+    0x285 => { #JR (not sure what is difference with 0x2f)
+        Name => 'ViewingMode2',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        PrintConv => {
+            0 => 'n/a',
+            16 => 'Viewfinder',
+            33 => 'Focus Check Live View',
+            34 => 'Quick AF Live View',
+        },
+    },
+    0x286 => { #JR
+        Name => 'AELock',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        PrintConv => {
+            1 => 'On',
+            2 => 'Off',
+        },
+    },
+    0x287 => { #JR
+        Name => 'FlashStatusBuilt-in',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        Notes => 'A450, A500 and A550',
+        PrintConv => {
+            1 => 'Off',
+            2 => 'On',
+        },
+    },
+    0x288 => { #JR
+        Name => 'FlashStatusExternal',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        Notes => 'A450, A500 and A550',
+        PrintConv => {
+            1 => 'None',
+            2 => 'Off',
+            3 => 'On',
+        },
+    },
+    0x28b => { #JR
+        Name => 'LiveViewFocusMode',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        PrintConv => {
+            0 => 'n/a',
+            1 => 'AF',
+            16 => 'Manual',
+        },
+    },
+    0x30c => { #JR
+        Name => 'SequenceNumber',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        Notes => 'A450, A500 and A550',
+        # normally 0; seen 2 for HDR
+        PrintConv => {
+            0 => 'Single',
+            255 => 'n/a',
+            OTHER => sub { shift }, # pass all other numbers straight through
+        },
+    },
+    0x314 => { #JR
+        Name => 'ImageNumber',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        Format => 'int16u',
+        Notes => 'A450, A500 and A550',
+        Mask => 0x3fff, #PH (not sure what the upper 2 bits are for)
+        PrintConv => 'sprintf("%.4d",$val)',
+        PrintConvInv => '$val',
+    },
+    0x316 => { #JR
+        Name => 'FolderNumber',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        Notes => 'A450, A500 and A550',
+        Format => 'int16u',
+        Mask => 0x03ff, #(NC)
+        PrintConv => 'sprintf("%.3d",$val)',
+        PrintConvInv => '$val',
+    },
+    0x03f0 => {
+        Name => 'LensE-mountVersion',
+        Format => 'int16u',
+        Condition => '($$self{Model} =~ /^NEX-/)',
+        PrintConv => 'sprintf("%x.%.2x",$val>>8,$val&0xff)',
+        PrintConvInv => 'my @a=split(/\./,$val);(hex($a[0])<<8)|hex($a[1])',
+    },
+    # 0x03f3 - this is probably LensFirmwareVersion and not CameraE-MountVersion (ref JR, Sept.2015)
+    # 0x03f3 and 0x03f4 change together and behave similarly to Tag940c 0x0014 and 0x0015 - see comments there.
+    0x03f3 => {
+        Name => 'LensFirmwareVersion',
+        Format => 'int16u',
+        Condition => '($$self{Model} =~ /^NEX-/)',
+        PrintConv => 'sprintf("Ver.%.2x.%.3d",$val>>8,$val&0xff)',
+    },
+    0x3f7 => { #JR
+        Name => 'LensType2',
+        Condition => '($$self{Model} =~ /^NEX-/) and ($$self{LensMount} != 1)',
+        Format => 'int16u',
+        SeparateTable => 'LensType2',
+        PrintConv => \%sonyLensTypes2,
+    },
+    0x400 => { #JR
+        Name => 'ImageNumber',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        Format => 'int16u',
+        Notes => 'A450, A500 and A550',
+        Mask => 0x3fff, #PH (not sure what the upper 2 bits are for)
+        PrintConv => 'sprintf("%.4d",$val)',
+        PrintConvInv => '$val',
+    },
+    0x402 => { #JR
+        Name => 'FolderNumber',
+        Condition => '$$self{Model} =~ /^DSLR-(A450|A500|A550)$/',
+        Format => 'int16u',
+        Mask => 0x03ff, #(NC)
+        Notes => 'A450, A500 and A550',
+        PrintConv => 'sprintf("%.3d",$val)',
+        PrintConvInv => '$val',
+    },
 );
 
